package com.cqxf.prometheus.alert.entity.alert;
import com.cqxf.prometheus.alert.constant.Constant;
import lombok.Data;

import java.util.List;
import java.util.Map;

@Data
public class PrometheusAlert {

    private String receiver;
    private String status;
    private List<Alerts> alerts;
    private Map<String, String> groupLabels;
    private Map<String, String> commonLabels;
    private CommonAnnotations commonAnnotations;
    private String externalURL;
    private String version;
    private String groupKey;
    private int truncatedAlerts;

    /**
     * 是否已处理
     * @return
     */
    public boolean isFiring() {
        return Constant.FIRING.equals(this.status);
    }

    /**
     * 是否已处理
     * @return
     */
    public boolean isResolved() {
        return Constant.RESOLVED.equals(this.status);
    }


}